notes: implement helpers needed for note copying during rewrite
[git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
12
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
19
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
22
23 Example:       git-rebase master~1 topic
24
25         A---B---C topic                   A'\''--B'\''--C'\'' topic
26        /                   -->           /
27   D---E---F---G master          D---E---F---G master
28 '
29
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
36
37 LF='
38 '
39 OK_TO_SKIP_PRE_REBASE=
40 RESOLVEMSG="
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
44 "
45 unset newbase
46 strategy=recursive
47 do_merge=
48 dotest="$GIT_DIR"/rebase-merge
49 prec=4
50 verbose=
51 diffstat=$(git config --bool rebase.stat)
52 git_am_opt=
53 rebase_root=
54 force_rebase=
55 allow_rerere_autoupdate=
56
57 continue_merge () {
58         test -n "$prev_head" || die "prev_head must be defined"
59         test -d "$dotest" || die "$dotest directory does not exist"
60
61         unmerged=$(git ls-files -u)
62         if test -n "$unmerged"
63         then
64                 echo "You still have unmerged paths in your index"
65                 echo "did you forget to use git add?"
66                 die "$RESOLVEMSG"
67         fi
68
69         cmt=`cat "$dotest/current"`
70         if ! git diff-index --quiet --ignore-submodules HEAD --
71         then
72                 if ! git commit --no-verify -C "$cmt"
73                 then
74                         echo "Commit failed, please do not call \"git commit\""
75                         echo "directly, but instead do one of the following: "
76                         die "$RESOLVEMSG"
77                 fi
78                 if test -z "$GIT_QUIET"
79                 then
80                         printf "Committed: %0${prec}d " $msgnum
81                 fi
82                 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
83         else
84                 if test -z "$GIT_QUIET"
85                 then
86                         printf "Already applied: %0${prec}d " $msgnum
87                 fi
88         fi
89         if test -z "$GIT_QUIET"
90         then
91                 git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
92         fi
93
94         prev_head=`git rev-parse HEAD^0`
95         # save the resulting commit so we can read-tree on it later
96         echo "$prev_head" > "$dotest/prev_head"
97
98         # onto the next patch:
99         msgnum=$(($msgnum + 1))
100         echo "$msgnum" >"$dotest/msgnum"
101 }
102
103 call_merge () {
104         cmt="$(cat "$dotest/cmt.$1")"
105         echo "$cmt" > "$dotest/current"
106         hd=$(git rev-parse --verify HEAD)
107         cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
108         msgnum=$(cat "$dotest/msgnum")
109         end=$(cat "$dotest/end")
110         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
111         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
112         export GITHEAD_$cmt GITHEAD_$hd
113         if test -n "$GIT_QUIET"
114         then
115                 export GIT_MERGE_VERBOSITY=1
116         fi
117         git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
118         rv=$?
119         case "$rv" in
120         0)
121                 unset GITHEAD_$cmt GITHEAD_$hd
122                 return
123                 ;;
124         1)
125                 git rerere $allow_rerere_autoupdate
126                 die "$RESOLVEMSG"
127                 ;;
128         2)
129                 echo "Strategy: $rv $strategy failed, try another" 1>&2
130                 die "$RESOLVEMSG"
131                 ;;
132         *)
133                 die "Unknown exit code ($rv) from command:" \
134                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
135                 ;;
136         esac
137 }
138
139 move_to_original_branch () {
140         test -z "$head_name" &&
141                 head_name="$(cat "$dotest"/head-name)" &&
142                 onto="$(cat "$dotest"/onto)" &&
143                 orig_head="$(cat "$dotest"/orig-head)"
144         case "$head_name" in
145         refs/*)
146                 message="rebase finished: $head_name onto $onto"
147                 git update-ref -m "$message" \
148                         $head_name $(git rev-parse HEAD) $orig_head &&
149                 git symbolic-ref HEAD $head_name ||
150                 die "Could not move back to $head_name"
151                 ;;
152         esac
153 }
154
155 finish_rb_merge () {
156         move_to_original_branch
157         if test -x "$GIT_DIR"/hooks/post-rewrite &&
158                 test -s "$dotest"/rewritten; then
159                 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
160         fi
161         rm -r "$dotest"
162         say All done.
163 }
164
165 is_interactive () {
166         while test $# != 0
167         do
168                 case "$1" in
169                         -i|--interactive)
170                                 interactive_rebase=explicit
171                                 break
172                         ;;
173                         -p|--preserve-merges)
174                                 interactive_rebase=implied
175                         ;;
176                 esac
177                 shift
178         done
179
180         if [ "$interactive_rebase" = implied ]; then
181                 GIT_EDITOR=:
182                 export GIT_EDITOR
183         fi
184
185         test -n "$interactive_rebase" || test -f "$dotest"/interactive
186 }
187
188 run_pre_rebase_hook () {
189         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
190            test -x "$GIT_DIR/hooks/pre-rebase"
191         then
192                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
193                 die "The pre-rebase hook refused to rebase."
194         fi
195 }
196
197 test -f "$GIT_DIR"/rebase-apply/applying &&
198         die 'It looks like git-am is in progress. Cannot rebase.'
199
200 is_interactive "$@" && exec git-rebase--interactive "$@"
201
202 if test $# -eq 0
203 then
204         test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
205         test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
206                 die 'A rebase is in progress, try --continue, --skip or --abort.'
207         die "No arguments given and $GIT_DIR/rebase-apply already exists."
208 fi
209
210 while test $# != 0
211 do
212         case "$1" in
213         --no-verify)
214                 OK_TO_SKIP_PRE_REBASE=yes
215                 ;;
216         --continue)
217                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
218                         die "No rebase in progress?"
219
220                 git diff-files --quiet --ignore-submodules || {
221                         echo "You must edit all merge conflicts and then"
222                         echo "mark them as resolved using git add"
223                         exit 1
224                 }
225                 if test -d "$dotest"
226                 then
227                         prev_head=$(cat "$dotest/prev_head")
228                         end=$(cat "$dotest/end")
229                         msgnum=$(cat "$dotest/msgnum")
230                         onto=$(cat "$dotest/onto")
231                         GIT_QUIET=$(cat "$dotest/quiet")
232                         continue_merge
233                         while test "$msgnum" -le "$end"
234                         do
235                                 call_merge "$msgnum"
236                                 continue_merge
237                         done
238                         finish_rb_merge
239                         exit
240                 fi
241                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
242                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
243                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
244                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
245                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
246                 move_to_original_branch
247                 exit
248                 ;;
249         --skip)
250                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
251                         die "No rebase in progress?"
252
253                 git reset --hard HEAD || exit $?
254                 if test -d "$dotest"
255                 then
256                         git rerere clear
257                         prev_head=$(cat "$dotest/prev_head")
258                         end=$(cat "$dotest/end")
259                         msgnum=$(cat "$dotest/msgnum")
260                         msgnum=$(($msgnum + 1))
261                         onto=$(cat "$dotest/onto")
262                         GIT_QUIET=$(cat "$dotest/quiet")
263                         while test "$msgnum" -le "$end"
264                         do
265                                 call_merge "$msgnum"
266                                 continue_merge
267                         done
268                         finish_rb_merge
269                         exit
270                 fi
271                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
272                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
273                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
274                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
275                 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
276                 move_to_original_branch
277                 exit
278                 ;;
279         --abort)
280                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
281                         die "No rebase in progress?"
282
283                 git rerere clear
284                 if test -d "$dotest"
285                 then
286                         GIT_QUIET=$(cat "$dotest/quiet")
287                         move_to_original_branch
288                 else
289                         dotest="$GIT_DIR"/rebase-apply
290                         GIT_QUIET=$(cat "$dotest/quiet")
291                         move_to_original_branch
292                 fi
293                 git reset --hard $(cat "$dotest/orig-head")
294                 rm -r "$dotest"
295                 exit
296                 ;;
297         --onto)
298                 test 2 -le "$#" || usage
299                 newbase="$2"
300                 shift
301                 ;;
302         -M|-m|--m|--me|--mer|--merg|--merge)
303                 do_merge=t
304                 ;;
305         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
306                 --strateg=*|--strategy=*|\
307         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
308                 case "$#,$1" in
309                 *,*=*)
310                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
311                 1,*)
312                         usage ;;
313                 *)
314                         strategy="$2"
315                         shift ;;
316                 esac
317                 do_merge=t
318                 ;;
319         -n|--no-stat)
320                 diffstat=
321                 ;;
322         --stat)
323                 diffstat=t
324                 ;;
325         -v|--verbose)
326                 verbose=t
327                 diffstat=t
328                 GIT_QUIET=
329                 ;;
330         -q|--quiet)
331                 GIT_QUIET=t
332                 git_am_opt="$git_am_opt -q"
333                 verbose=
334                 diffstat=
335                 ;;
336         --whitespace=*)
337                 git_am_opt="$git_am_opt $1"
338                 case "$1" in
339                 --whitespace=fix|--whitespace=strip)
340                         force_rebase=t
341                         ;;
342                 esac
343                 ;;
344         --ignore-whitespace)
345                 git_am_opt="$git_am_opt $1"
346                 ;;
347         --committer-date-is-author-date|--ignore-date)
348                 git_am_opt="$git_am_opt $1"
349                 force_rebase=t
350                 ;;
351         -C*)
352                 git_am_opt="$git_am_opt $1"
353                 ;;
354         --root)
355                 rebase_root=t
356                 ;;
357         -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
358                 force_rebase=t
359                 ;;
360         --rerere-autoupdate|--no-rerere-autoupdate)
361                 allow_rerere_autoupdate="$1"
362                 ;;
363         -*)
364                 usage
365                 ;;
366         *)
367                 break
368                 ;;
369         esac
370         shift
371 done
372 test $# -gt 2 && usage
373
374 # Make sure we do not have $GIT_DIR/rebase-apply
375 if test -z "$do_merge"
376 then
377         if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
378         then
379                 rmdir "$GIT_DIR"/rebase-apply
380         else
381                 echo >&2 '
382 It seems that I cannot create a rebase-apply directory, and
383 I wonder if you are in the middle of patch application or another
384 rebase.  If that is not the case, please
385         rm -fr '"$GIT_DIR"'/rebase-apply
386 and run me again.  I am stopping in case you still have something
387 valuable there.'
388                 exit 1
389         fi
390 else
391         if test -d "$dotest"
392         then
393                 die "previous rebase directory $dotest still exists." \
394                         'Try git rebase (--continue | --abort | --skip)'
395         fi
396 fi
397
398 # The tree must be really really clean.
399 if ! git update-index --ignore-submodules --refresh > /dev/null; then
400         echo >&2 "cannot rebase: you have unstaged changes"
401         git diff-files --name-status -r --ignore-submodules -- >&2
402         exit 1
403 fi
404 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
405 case "$diff" in
406 ?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
407         echo >&2 "$diff"
408         exit 1
409         ;;
410 esac
411
412 if test -z "$rebase_root"
413 then
414         # The upstream head must be given.  Make sure it is valid.
415         upstream_name="$1"
416         shift
417         upstream=`git rev-parse --verify "${upstream_name}^0"` ||
418         die "invalid upstream $upstream_name"
419         unset root_flag
420         upstream_arg="$upstream_name"
421 else
422         test -z "$newbase" && die "--root must be used with --onto"
423         unset upstream_name
424         unset upstream
425         root_flag="--root"
426         upstream_arg="$root_flag"
427 fi
428
429 # Make sure the branch to rebase onto is valid.
430 onto_name=${newbase-"$upstream_name"}
431 case "$onto_name" in
432 *...*)
433         if      left=${onto_name%...*} right=${onto_name#*...} &&
434                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
435         then
436                 case "$onto" in
437                 ?*"$LF"?*)
438                         die "$onto_name: there are more than one merge bases"
439                         ;;
440                 '')
441                         die "$onto_name: there is no merge base"
442                         ;;
443                 esac
444         else
445                 die "$onto_name: there is no merge base"
446         fi
447         ;;
448 *)
449         onto=$(git rev-parse --verify "${onto_name}^0") || exit
450         ;;
451 esac
452
453 # If a hook exists, give it a chance to interrupt
454 run_pre_rebase_hook "$upstream_arg" "$@"
455
456 # If the branch to rebase is given, that is the branch we will rebase
457 # $branch_name -- branch being rebased, or HEAD (already detached)
458 # $orig_head -- commit object name of tip of the branch before rebasing
459 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
460 switch_to=
461 case "$#" in
462 1)
463         # Is it "rebase other $branchname" or "rebase other $commit"?
464         branch_name="$1"
465         switch_to="$1"
466
467         if git show-ref --verify --quiet -- "refs/heads/$1" &&
468            branch=$(git rev-parse -q --verify "refs/heads/$1")
469         then
470                 head_name="refs/heads/$1"
471         elif branch=$(git rev-parse -q --verify "$1")
472         then
473                 head_name="detached HEAD"
474         else
475                 usage
476         fi
477         ;;
478 *)
479         # Do not need to switch branches, we are already on it.
480         if branch_name=`git symbolic-ref -q HEAD`
481         then
482                 head_name=$branch_name
483                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
484         else
485                 head_name="detached HEAD"
486                 branch_name=HEAD ;# detached
487         fi
488         branch=$(git rev-parse --verify "${branch_name}^0") || exit
489         ;;
490 esac
491 orig_head=$branch
492
493 # Now we are rebasing commits $upstream..$branch (or with --root,
494 # everything leading up to $branch) on top of $onto
495
496 # Check if we are already based on $onto with linear history,
497 # but this should be done only when upstream and onto are the same.
498 mb=$(git merge-base "$onto" "$branch")
499 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
500         # linear history?
501         ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
502 then
503         if test -z "$force_rebase"
504         then
505                 # Lazily switch to the target branch if needed...
506                 test -z "$switch_to" || git checkout "$switch_to"
507                 say "Current branch $branch_name is up to date."
508                 exit 0
509         else
510                 say "Current branch $branch_name is up to date, rebase forced."
511         fi
512 fi
513
514 # Detach HEAD and reset the tree
515 say "First, rewinding head to replay your work on top of it..."
516 git checkout -q "$onto^0" || die "could not detach HEAD"
517 git update-ref ORIG_HEAD $branch
518
519 if test -n "$diffstat"
520 then
521         if test -n "$verbose"
522         then
523                 echo "Changes from $mb to $onto:"
524         fi
525         # We want color (if set), but no pager
526         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
527 fi
528
529 # If the $onto is a proper descendant of the tip of the branch, then
530 # we just fast-forwarded.
531 if test "$mb" = "$branch"
532 then
533         say "Fast-forwarded $branch_name to $onto_name."
534         move_to_original_branch
535         exit 0
536 fi
537
538 if test -n "$rebase_root"
539 then
540         revisions="$onto..$orig_head"
541 else
542         revisions="$upstream..$orig_head"
543 fi
544
545 if test -z "$do_merge"
546 then
547         git format-patch -k --stdout --full-index --ignore-if-in-upstream \
548                 $root_flag "$revisions" |
549         git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
550         move_to_original_branch
551         ret=$?
552         test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
553                 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
554                 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
555                 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
556                 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
557         exit $ret
558 fi
559
560 # start doing a rebase with git-merge
561 # this is rename-aware if the recursive (default) strategy is used
562
563 mkdir -p "$dotest"
564 echo "$onto" > "$dotest/onto"
565 echo "$onto_name" > "$dotest/onto_name"
566 prev_head=$orig_head
567 echo "$prev_head" > "$dotest/prev_head"
568 echo "$orig_head" > "$dotest/orig-head"
569 echo "$head_name" > "$dotest/head-name"
570 echo "$GIT_QUIET" > "$dotest/quiet"
571
572 msgnum=0
573 for cmt in `git rev-list --reverse --no-merges "$revisions"`
574 do
575         msgnum=$(($msgnum + 1))
576         echo "$cmt" > "$dotest/cmt.$msgnum"
577 done
578
579 echo 1 >"$dotest/msgnum"
580 echo $msgnum >"$dotest/end"
581
582 end=$msgnum
583 msgnum=1
584
585 while test "$msgnum" -le "$end"
586 do
587         call_merge "$msgnum"
588         continue_merge
589 done
590
591 finish_rb_merge